#version 150
//#version 120
//#extension GL_ARB_geometry_shader4 : enable

// http://www.lighthouse3d.com/tutorials/glsl-core-tutorial/geometry-shader/
// http://www.lighthouse3d.com/tutorials/glsl-core-tutorial/geometry-shader-examples/
// http://renderingwonders.wordpress.com/2011/02/07/chapter-11-%E2%80%93-advanced-shader-usage-geometry-shaders/

layout (points) in;
layout (triangle_strip, max_vertices = 4) out;

uniform mat4 viewMatrix;
uniform mat4 projMat;

uniform vec3 sel_pos;
uniform float particle_mode;
uniform float particle_scale;

//varying vec3 color;
varying in vec3 color[];
varying out vec3 outcolor;

void main() 
{
	
	//if (gl_in[0].gl_Position.x > sel_pos.x - 0.4 &&
	//	gl_in[0].gl_Position.x < sel_pos.x + 0.4 &&
	//	gl_in[0].gl_Position.y > sel_pos.y - 0.4 &&
	//	gl_in[0].gl_Position.y < sel_pos.y + 0.4 &&
	//	gl_in[0].gl_Position.z > sel_pos.z - 0.4 &&
	//	gl_in[0].gl_Position.z < sel_pos.z + 0.4) {
	//	//color = vec3(1.0, 0.0, 0.0);
	//}
	//else color = vec3(1.0, 1.0, 1.0);
	
	vec4 pos = gl_in[0].gl_Position;
	if (particle_mode > 0.4) pos.z = -4.0f;
	//float s = 0.0025f;
	float s = particle_scale;
	
	outcolor = color[0];
	//if (color[0].g < 0.01 && color[0].r > 0.9) {
	//	outcolor.rgb = vec3(color[0].r);
	//	s = 0.06f;
	//}
	
	//v150: gl_in[0].gl_Position v120:gl_PositionIn
	gl_Position = projMat * (viewMatrix * pos + vec4(-s, -s, 0.0f, 1.0f));
	//outcolor = color[0];
	EmitVertex();
	
	gl_Position = projMat * (viewMatrix * pos + vec4(s, -s, 0.0f, 1.0f)); //0.004
	//outcolor = color[0];
	EmitVertex();
	
	gl_Position = projMat * (viewMatrix * pos + vec4(-s, s, 0.0f, 1.0f));
	//outcolor = color[0];
	EmitVertex();
	
	gl_Position = projMat * (viewMatrix * pos + vec4(s, s, 0.0f, 1.0f));
	//outcolor = color[0];
	EmitVertex();
	
	EndPrimitive();
	
}