package gkdtree;

/**
 * 
 * Provides static implementation for distance functions.
 * 
 * @author DarkMatt
 *
 */

public class Distance {

	/**
	 * Euclidean distance between two arbitrary dimensional points.
	 * 
	 * @param a
	 * @param b
	 * @return float
	 */
	public static float euclidean(float[] a, float[] b) {
		int d = a.length;
		float out = 0.0f;
		
		for (int i=0; i<d; i++) {
			out += (a[i]-b[i])*(a[i]-b[i]);
		}
		
		return (float)Math.sqrt(out);
	}
	
}
