package io;

import java.util.Arrays;

import org.lwjgl.input.Keyboard;
import org.lwjgl.input.Mouse;

/**
 *
 * KeyStates define what states are active due to key events.
 * 
 * @author DarkMatt
 *
 */

public class KeyStates {

	public float mouse_sensitivity = 0.1f;
	
	public boolean shut_down;
	
	public boolean rotate_left, rotate_right;
	public float rotate_vertical, rotate_horizontal;
	public boolean move_left, move_right, move_fwd, move_bwd, move_up, move_down;
	public boolean arrow_up, arrow_down, arrow_upactive, arrow_downactive;
	public boolean arrow_left, arrow_right, arrow_leftactive, arrow_rightactive;
	public boolean action, actionactive;
	public boolean enter, enteractive;
	public boolean v_key, v_keyactive;
	public boolean b_key, b_keyactive;
	public boolean back_key, back_keyactive;
	public boolean dot_key, dot_keyactive;
	public boolean digits[];
	public boolean digits_active[];
	
	public boolean active_loading = false;
	
	private float dx, dy;
	
	public KeyStates() {
		
		arrow_upactive = false;
		arrow_downactive = false;
		arrow_leftactive = false;
		arrow_rightactive = false;
		actionactive = false;
		enteractive = false;
		v_keyactive = false;
		b_keyactive = false;
		back_keyactive = false;
		dot_keyactive = false;
		
		digits = new boolean[10];
		Arrays.fill(digits, false);
		digits_active = new boolean[10];
		Arrays.fill(digits_active, false);
		
		reset();
	}
	
	public void reset() {
		shut_down = false;
		rotate_left = false; rotate_right = false;
		//rotate_vertical = 0.0f; rotate_horizontal = 0.0f;
		move_left = false; move_right = false; move_fwd = false; move_bwd = false; move_up = false; move_down = false;
		arrow_up = false; arrow_down = false; arrow_left = false; arrow_right = false;
		action = false;
		enter = false;
		v_key = false;
		b_key = false;
		back_key = false;
		dot_key = false;
		Arrays.fill(digits, false);
	}
	
	public void apply_key() {
		

		//!Keyboard.isKeyDown(Keyboard.KEY_SPACE)
		if (!Mouse.isButtonDown(0)) {
			actionactive = false;
		}
		if (!actionactive && Mouse.isButtonDown(0)) {
			actionactive = true;
			action = true;
		}
		if (!Keyboard.isKeyDown(Keyboard.KEY_UP)) {
			arrow_upactive = false;
		}
		if (!arrow_upactive && Keyboard.isKeyDown(Keyboard.KEY_UP)) {
			arrow_upactive = true;
			arrow_up = true;
		}
		if (!Keyboard.isKeyDown(Keyboard.KEY_DOWN)) {
			arrow_downactive = false;
		}
		if (!arrow_downactive && Keyboard.isKeyDown(Keyboard.KEY_DOWN)) {
			arrow_downactive = true;
			arrow_down = true;
		}
		if (!Keyboard.isKeyDown(Keyboard.KEY_LEFT)) {
			arrow_leftactive = false;
		}
		if (!arrow_leftactive && Keyboard.isKeyDown(Keyboard.KEY_LEFT)) {
			arrow_leftactive = true;
			arrow_left = true;
		}
		if (!Keyboard.isKeyDown(Keyboard.KEY_RIGHT)) {
			arrow_rightactive = false;
		}
		if (!arrow_rightactive && Keyboard.isKeyDown(Keyboard.KEY_RIGHT)) {
			arrow_rightactive = true;
			arrow_right = true;
		}
		if (!Keyboard.isKeyDown(Keyboard.KEY_RETURN)) {
			enteractive = false;
		}
		if (!enteractive && Keyboard.isKeyDown(Keyboard.KEY_RETURN)) {
			enteractive = true;
			enter = true;
		}
		if (!Keyboard.isKeyDown(Keyboard.KEY_V)) {
			v_keyactive = false;
		}
		if (!v_keyactive && Keyboard.isKeyDown(Keyboard.KEY_V)) {
			v_keyactive = true;
			v_key = true;
		}
		if (!Keyboard.isKeyDown(Keyboard.KEY_B)) {
			b_keyactive = false;
		}
		if (!b_keyactive && Keyboard.isKeyDown(Keyboard.KEY_B)) {
			b_keyactive = true;
			b_key = true;
		}
		for (int i=0; i<digits.length; i++) {
			if (!Keyboard.isKeyDown(Keyboard.KEY_1 + i)) {
				digits_active[i] = false;
			}
			if (!digits_active[i] && Keyboard.isKeyDown(Keyboard.KEY_1 + i)) {
				digits_active[i] = true;
				digits[i] = true;
			}
		}
		if (!Keyboard.isKeyDown(Keyboard.KEY_BACK)) {
			back_keyactive = false;
		}
		if (!back_keyactive && Keyboard.isKeyDown(Keyboard.KEY_BACK)) {
			back_keyactive = true;
			back_key = true;
		}
		if (!Keyboard.isKeyDown(Keyboard.KEY_PERIOD)) {
			dot_keyactive = false;
		}
		if (!dot_keyactive && Keyboard.isKeyDown(Keyboard.KEY_PERIOD)) {
			dot_keyactive = true;
			dot_key = true;
		}
		
		if (Keyboard.isKeyDown(Keyboard.KEY_ESCAPE)) {
			shut_down = true;
		}
		
		if (Keyboard.isKeyDown(Keyboard.KEY_W)) {
			move_fwd = true;
		}
		if (Keyboard.isKeyDown(Keyboard.KEY_S)) {
			move_bwd = true;
		}
		if (Keyboard.isKeyDown(Keyboard.KEY_A)) {
			move_left = true;
		}
		if (Keyboard.isKeyDown(Keyboard.KEY_D)) {
			move_right = true;
		}
		
		/*if (Keyboard.isKeyDown(Keyboard.KEY_LEFT)) {
			rotate_left = true;
		}
		if (Keyboard.isKeyDown(Keyboard.KEY_RIGHT)) {
			rotate_right = true;
		}*/
		
		if (Keyboard.isKeyDown(Keyboard.KEY_Q)) {
			move_up = true;
		}
		if (Keyboard.isKeyDown(Keyboard.KEY_Y)) {
			move_down = true;
		}
		
		//MOuse:!"12 0.>
		//dx = Mouse.getDX();
        //dy = Mouse.getDY();
        
        //rotate_vertical = -dx * mouse_sensitivity;
        //rotate_horizontal = dy * mouse_sensitivity;
        
        //weird mouse steering... (maybe change to shooter mouse steering...)
		//if (dx < -0.1f) rotate_left = true;
		//if (dx > 0.1f) rotate_right = true;
		//if (dy < -0.1f) rotate_down = true;
		//if (dy > 0.1f) rotate_up = true;
        
        //controll camera yaw from x movement fromt the mouse
        //camera.yaw(dx * mouseSensitivity);
        //controll camera pitch from y movement fromt the mouse
        //camera.pitch(- dy * mouseSensitivity); 
		
	}
	
}
