package loader;

import java.util.Random;

/**
 *
 * The ObjectLoader handles loading of objects (files, procedural geometry, etc)
 * 
 * (not fully implemented yet)
 * 
 * @author DarkMatt
 *
 */

public class ObjectLoader {

	private float[] vertices;
	private float[] textCoords;
	
	public ObjectLoader(String type) {
		
		initializeObject(type);
		
	}
	
	private void initializeObject(String type) {
		if (type.equals("plane")) {
			vertices = new float[4*3];
			//left upper
			vertices[0] = -1.0f;
			vertices[1] = -0.666f;
			vertices[2] = 0.0f;
			//right upper
			vertices[3] = 1.0f;
			vertices[4] = -0.666f;
			vertices[5] = 0.0f;
			//left lower
			vertices[6] = 1.0f;
			vertices[7] = 0.666f;
			vertices[8] = 0.0f;
			//right lower
			vertices[9] = -1.0f;
			vertices[10] = 0.666f;
			vertices[11] = 0.0f;
			
			textCoords = new float[4*2];
			textCoords[0] = 0.0f;
			textCoords[1] = 1.0f;
			textCoords[2] = 1.0f;
			textCoords[3] = 1.0f;
			textCoords[4] = 1.0f;
			textCoords[5] = 0.0f;
			textCoords[6] = 0.0f;
			textCoords[7] = 0.0f;
		}
		
		if (type.equals("random_points")) {
			
			int size = 5;
			vertices = new float[size*3];
			textCoords = new float[size*2];
			
			Random r = new Random();
			
			for (int i=0;i<size; i++) {
				vertices[3*i + 0] = r.nextFloat();
				vertices[3*i + 1] = r.nextFloat();
				vertices[3*i + 2] = r.nextFloat();
				textCoords[2*i + 0] = 0.5f;
				textCoords[2*i + 1] = 0.5f;
			}
			
			//System.out.println("created particles");
			
		}
		
		if (type.equals("quad")) {
			vertices = new float[4*3];
			//left upper
			vertices[0] = -1.0f;
			vertices[1] = -1.0f;
			vertices[2] = 0.0f;
			//right upper
			vertices[3] = 1.0f;
			vertices[4] = -1.0f;
			vertices[5] = 0.0f;
			//left lower
			vertices[6] = 1.0f;
			vertices[7] = 1.0f;
			vertices[8] = 0.0f;
			//right lower
			vertices[9] = -1.0f;
			vertices[10] = 1.0f;
			vertices[11] = 0.0f;
			
			textCoords = new float[4*2];
			textCoords[0] = 0.0f;
			textCoords[1] = 1.0f;
			textCoords[2] = 1.0f;
			textCoords[3] = 1.0f;
			textCoords[4] = 1.0f;
			textCoords[5] = 0.0f;
			textCoords[6] = 0.0f;
			textCoords[7] = 0.0f;
		}
		
		if (type.equals("cube")) {
			vertices = new float[4*4*3];
			//front-back
			//left upper
			vertices[0] = -1.0f;
			vertices[1] = -1.0f;
			vertices[2] = -1.0f;
			//right upper
			vertices[3] = 1.0f;
			vertices[4] = -1.0f;
			vertices[5] = -1.0f;
			//left lower
			vertices[6] = 1.0f;
			vertices[7] = 1.0f;
			vertices[8] = -1.0f;
			//right lower
			vertices[9] = -1.0f;
			vertices[10] = 1.0f;
			vertices[11] = -1.0f;
			//left upper
			vertices[12] = -1.0f;
			vertices[13] = -1.0f;
			vertices[14] = 1.0f;
			//right upper
			vertices[15] = 1.0f;
			vertices[16] = -1.0f;
			vertices[17] = 1.0f;
			//left lower
			vertices[18] = 1.0f;
			vertices[19] = 1.0f;
			vertices[20] = 1.0f;
			//right lower
			vertices[21] = -1.0f;
			vertices[22] = 1.0f;
			vertices[23] = 1.0f;
			
			//left-right
			//left upper
			vertices[24] = -1.0f;
			vertices[25] = -1.0f;
			vertices[26] = -1.0f;
			//right upper
			vertices[27] = -1.0f;
			vertices[28] = -1.0f;
			vertices[29] = 1.0f;
			//left lower
			vertices[30] = -1.0f;
			vertices[31] = 1.0f;
			vertices[32] = 1.0f;
			//right lower
			vertices[33] = -1.0f;
			vertices[34] = 1.0f;
			vertices[35] = -1.0f;
			//left upper
			vertices[36] = 1.0f;
			vertices[37] = -1.0f;
			vertices[38] = -1.0f;
			//right upper
			vertices[39] = 1.0f;
			vertices[40] = -1.0f;
			vertices[41] = 1.0f;
			//left lower
			vertices[42] = 1.0f;
			vertices[43] = 1.0f;
			vertices[44] = 1.0f;
			//right lower
			vertices[45] = 1.0f;
			vertices[46] = 1.0f;
			vertices[47] = -1.0f;
			
			textCoords = new float[4*4*2];
			textCoords[0] = 0.0f;
			textCoords[1] = 1.0f;
			textCoords[2] = 1.0f;
			textCoords[3] = 1.0f;
			textCoords[4] = 1.0f;
			textCoords[5] = 0.0f;
			textCoords[6] = 0.0f;
			textCoords[7] = 0.0f;
		}
	}
	
	public float[] getTextCoords() {
		return textCoords;
	}
	
	public float[] getVertices() {
		return vertices;
	}
	
	public int getSize() {
		return vertices.length/3;
	}
	
}
