package rendertools;

/**
 *
 * Timer class, important for FPS.
 * 
 * @author DarkMatt
 *
 */

public class Timer {

	private boolean nano = true;
	
	private float dt;
	private long currentTime;
	private long current;
	
	private int MAX_SAPLES = 50;
	private int sample_counter = 0;
	private long fpsMeasure;
	private String fps = "";
	
	public Timer() {
		
	}
	
	//every loop
	public void startMeasure() {
		currentTime = System.nanoTime(); //currentTimeMillis
		if (sample_counter < MAX_SAPLES-1) sample_counter ++;
		else {
			fpsMeasure = currentTime;
			sample_counter = 0;
		}
	}
	
	//every loop
	public void endMeasure() {
		//System.out.println((System.currentTimeMillis() - currentTime));
		current = System.nanoTime() - currentTime;
		dt = (float)current/1000000000.0f;
		if (sample_counter == MAX_SAPLES-1) {
			float c = (float)(System.nanoTime() - fpsMeasure)/(float)MAX_SAPLES;
			
			String val = String.valueOf( 1000000000.f/c );
			int comma = val.indexOf('.');
			fps = String.valueOf( 1000000000.f/c ).substring(0, comma);
		}
	}
	
	public float dt() {
		return dt;
	}
	
	public String getFPS() {
		return fps;
	}
	
}
