package rendertools;


import java.nio.FloatBuffer;
import java.nio.IntBuffer;

import main.Entrance;

import org.lwjgl.BufferUtils;
import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL15;

/**
 *
 * VBO implementation.
 * 
 * @author DarkMatt
 *
 */

public class VBO {
	
	private IntBuffer vboId;
	
	/*
	 * Structure:
	 *  PROBLEM: delete on VBO?
	 */
	
	public VBO() {
		
	}
	
	public void init(float[] vertices, float[] textCoords, float[] vertColors, int size) {
		
		if (Entrance.DEBUG) System.out.println("5: Initializing VBOs...");
		
		/*IntBuffer ind = BufferUtils.createIntBuffer(size);
		int[] i = new int[]{0,1,2,3};
		ind.put(i);
		ind.position(0);*/
		
		vboId = BufferUtils.createIntBuffer(3);
		
		GL15.glGenBuffers(vboId);
		
		FloatBuffer in = BufferUtils.createFloatBuffer(3*size);
		in.put(vertices, 0, 3*size);
		in.position(0);
		
		GL15.glBindBuffer(GL15.GL_ARRAY_BUFFER, vboId.get(0));
		GL15.glBufferData(GL15.GL_ARRAY_BUFFER, in, GL15.GL_STREAM_DRAW);
		
		in = BufferUtils.createFloatBuffer(3*size);
		in.put(vertColors, 0, 3*size);
		in.position(0);
		
		/*System.out.println("Cursed");
		for(int i=0;i<vertColors.length;i++) if(vertColors[i] != 0) System.out.println(vertColors[i]);
		System.out.println("Cursed end");*/
		
		GL15.glBindBuffer(GL15.GL_ELEMENT_ARRAY_BUFFER, vboId.get(1));
		GL15.glBufferData(GL15.GL_ELEMENT_ARRAY_BUFFER, in, GL15.GL_STATIC_DRAW);
		
		in = BufferUtils.createFloatBuffer(2*size);
		in.put(textCoords, 0, 2*size);
		in.position(0);
		
		GL15.glBindBuffer(GL15.GL_ELEMENT_ARRAY_BUFFER, vboId.get(2));
		GL15.glBufferData(GL15.GL_ELEMENT_ARRAY_BUFFER, in, GL15.GL_STATIC_DRAW);
		
		//GL15.glBindBuffer(GL15.GL_ELEMENT_ARRAY_BUFFER, vboId.get(1));
		//GL15.glBufferData(GL15.GL_ELEMENT_ARRAY_BUFFER, ind, GL15.GL_STATIC_DRAW);
		
		GL15.glBindBuffer(GL15.GL_ARRAY_BUFFER, 0);
		GL15.glBindBuffer(GL15.GL_ELEMENT_ARRAY_BUFFER, 0);
		
		if (Entrance.DEBUG) System.out.println("6: Done VBO");
	}
	
	public void update(float[] vertices, int start, int size) {
		
		FloatBuffer in = BufferUtils.createFloatBuffer(3*size);
		in.put(vertices, start, 3*size);
		in.position(0);
		
		GL15.glBindBuffer(GL15.GL_ARRAY_BUFFER, vboId.get(0));
		GL15.glBufferSubData(GL15.GL_ARRAY_BUFFER, (long)(4*start), in);
		GL15.glBindBuffer(GL15.GL_ARRAY_BUFFER, 0);
		
	}
	
	public void update(float[] vertices, float[] colors, int start, int size) {
		
		FloatBuffer in = BufferUtils.createFloatBuffer(3*size);
		in.put(vertices, start, 3*size);
		in.position(0);
		
		GL15.glBindBuffer(GL15.GL_ARRAY_BUFFER, vboId.get(0));
		GL15.glBufferSubData(GL15.GL_ARRAY_BUFFER, (long)(4*start), in);
		GL15.glBindBuffer(GL15.GL_ARRAY_BUFFER, 0);
		
		in = BufferUtils.createFloatBuffer(3*size);
		in.put(colors, start, 3*size);
		in.position(0);
		
		GL15.glBindBuffer(GL15.GL_ARRAY_BUFFER, vboId.get(1));
		GL15.glBufferSubData(GL15.GL_ARRAY_BUFFER, (long)(4*start), in);
		GL15.glBindBuffer(GL15.GL_ARRAY_BUFFER, 0);
		
	}
	
	public void render(int type, int startIndex, int endIndex) {
		
		GL15.glBindBuffer(GL15.GL_ARRAY_BUFFER, vboId.get(0));
		GL11.glEnableClientState(GL11.GL_VERTEX_ARRAY);
		GL11.glVertexPointer(3, GL11.GL_FLOAT, 0, 0);
		
		GL15.glBindBuffer(GL15.GL_ARRAY_BUFFER, vboId.get(1)); 		//for texturecorrds
		GL11.glEnableClientState(GL11.GL_COLOR_ARRAY);      //activate texturecorrds array
		GL11.glColorPointer(3, GL11.GL_FLOAT, 0, 0);
		
		GL15.glBindBuffer(GL15.GL_ARRAY_BUFFER, vboId.get(2)); 		//for texturecorrds
		GL11.glEnableClientState(GL11.GL_TEXTURE_COORD_ARRAY);      //activate texturecorrds array
		GL11.glTexCoordPointer(2, GL11.GL_FLOAT, 0, 0);
		
		GL11.glDrawArrays(type, startIndex, endIndex-startIndex);
		//GL11.glDrawArrays(GL11.GL_POINTS, startIndex, endIndex-startIndex);
		//GL11.glDrawArrays(GL11.GL_TRIANGLES, startIndex, endIndex-startIndex);
		
		GL15.glBindBuffer(GL15.GL_ARRAY_BUFFER, 0);
		GL15.glBindBuffer(GL15.GL_ELEMENT_ARRAY_BUFFER, 0);
	}
	
}
