package rendertools;

/**
 *
 * Static math functionality based on float arrays.
 * 
 * @author DarkMatt
 *
 */

public class VecMath {

	public static float[] cross(float[] v1, float[] v2) {
		float[] out = new float[3];
		out[0] = v1[1]*v2[2]-v1[2]*v2[1];
		out[1] = v1[2]*v2[0]-v1[0]*v2[2];
		out[2] = v1[0]*v2[1]-v1[1]*v2[0];
		return out;
	}
	
	public static float dot(float[] v1, float[] v2) {
		return v1[0]*v2[0]+v1[1]*v2[1]+v1[2]*v2[2];
	}
	
	public static float[] sub(float[] v1, float[] v2) {
		float[] out = new float[3];
		out[0] = v1[0]-v2[0];
		out[1] = v1[1]-v2[1];
		out[2] = v1[2]-v2[2];
		return out;
	}
	
}
